//+------------------------------------------------------------------+
//|                                                   FLI_MM_ADX.mq4 |
//|                   Copyright  2009, Francesco Marasco aka flinux |
//|                                       E-Mail: fmarasco@gmail.com |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators.                                         |
//|                                                                  |
//|   PayPal - fmarasco@gmail.com                                    |
//+------------------------------------------------------------------+

#property copyright "Francesco Marasco"
#property link      "http://www.togetherteam.net"

#property indicator_chart_window

extern bool  Show.Heading  =  true ;  
extern int  yAxis  = 80 ;
extern int  Corner = 1;

extern color TextColor    = White;
extern color HiLightColor = Magenta;
extern int adxPeriod = 14;
extern int adxLevel = 25;
extern int dipLevel = 25;
extern int dimLevel = 25;

int tframe[]={1,5,15,30,60,240,1440,10080,43200};
string tf[]={"M1","M5","M15","M30","H1","H4","D1","W1","MN","TOT"};
int tfnumber=9,columns=9 ;  
string TimeFrameStr;
double IndVal[9],IndValD[9] , CMI[9];
int xpos[10];
int w, j, xposTAG;
string TAG = "FLIMMADX";
string  theArrow[10];
color   theColor[10];
string symbol;
int    digits, period, i; 
double point ;
color  hdColor ;  
double  adx,dip,dim;
bool firsttime  =  true ;
string   ArrowUp;
string   ArrowDn;
string   NoSignalArrow; 
bool foundUpper, foundLower;
int  BarsAgoUpper, BarsAgoLower;
int   UpFractalSymbol    = 217;
int   DnFractalSymbol    = 218;
int   NoSignalSymbol     = 108;




int init()
{
   ArrowDn       = CharToStr(DnFractalSymbol) ;
   ArrowUp       = CharToStr(UpFractalSymbol) ;
   NoSignalArrow = CharToStr(NoSignalSymbol) ; 
   
   deinit();

   period       = Period() ;   
   symbol       = Symbol() ;
   digits       =  Digits ;   
   point        =  Point ; 

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
 

   if(Corner == 1 || Corner == 3)
   { 
      for( w = 0 ; w < columns ; w++) { xpos[w] = 15 + ((10 - w)*23) ; } 
      xposTAG = 270 ;
   } 
   else
   {
      for( w=0;w<columns;w++) { xpos[w] = w*23 + 50 ; }
      xposTAG = 10 ;
   }
  
   return(0);
} 

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
   {
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix) 
      { 
         i++; 
         continue;
      }
      ObjectDelete(ObjName);
   }
}
    
int deinit()
{
   ObDeleteObjectsByPrefix(TAG);  
   return(0);
}
  
int start()
{
   if(firsttime)
   {
      firsttime  =  false ;
      
      ObjectCreate(TAG+"HD1",OBJ_LABEL,0,0,0,0,0);
      ObjectSet(TAG+"HD1",OBJPROP_CORNER,Corner);
      ObjectSet(TAG+"HD1",OBJPROP_XDISTANCE,xposTAG);
      ObjectSet(TAG+"HD1",OBJPROP_YDISTANCE,yAxis+30);
      ObjectSetText(TAG+"HD1", "FLI_ADX_MM" ,8,"Tahoma",TextColor);
      
      if(Show.Heading)
      {
         for( w = 0;w<columns;w++)
         {
            if(tframe[w]  ==  period) { hdColor  =  HiLightColor ; }
            else  { hdColor  =  TextColor ; }
      
            ObjectCreate(TAG+tf[w],OBJ_LABEL,0,0,0,0,0);
            ObjectSet(TAG+tf[w],OBJPROP_CORNER,Corner);
            ObjectSet(TAG+tf[w],OBJPROP_XDISTANCE,xpos[w]);
            ObjectSet(TAG+tf[w],OBJPROP_YDISTANCE,yAxis+15);
            ObjectSetText(TAG+tf[w],tf[w],8,"Tahoma",hdColor);                     
         }
      } // if
   
   
   }  // if(firsttime)

   for( j=0;j<columns ;j++)
   {
      if (ObjectFind(TAG+j) != 0)
      {
         ObjectCreate(TAG+j+"C",OBJ_LABEL,0,0,0,0,0);        
         ObjectSet(TAG+j+"C",OBJPROP_CORNER,Corner);
         ObjectSet(TAG+j+"C",OBJPROP_XDISTANCE,xpos[j]);
         ObjectSet(TAG+j+"C",OBJPROP_YDISTANCE,yAxis+30);
         ObjectSetText(TAG+j+"C","00",8,"Tahoma",White);
      }// if
   } // for
    
   for(int x=0;x<tfnumber;x++)
   {
      adx = iADX(symbol, tframe[x], adxPeriod, PRICE_CLOSE, MODE_MAIN, 0);
      dip = iADX(symbol, tframe[x], adxPeriod, PRICE_CLOSE, MODE_PLUSDI, 0);
      dim = iADX(symbol, tframe[x], adxPeriod, PRICE_CLOSE, MODE_MINUSDI, 0);

      if (adx>adxLevel)
      {
         if (dip>dipLevel) { theArrow[x]=ArrowUp; theColor[x]=ForestGreen; }
         else if (dim>dimLevel) { theArrow[x]=ArrowDn; theColor[x]=FireBrick; }
         else { theArrow[x]=NoSignalArrow; theColor[x]=Yellow; }
      }
      else
      {
         theArrow[x] = NoSignalArrow;
         theColor[x] = Yellow;
      }

      for(int  y=0;y<columns;y++)
      { 
         ObjectSetText(TAG+y+"C",theArrow[y] ,10,"Wingdings",theColor[y]);
      }  
  
   } // for
   return(0);
}

